package com.iformall.controller.market;

import com.github.pagehelper.PageInfo;
import com.iformall.annotation.SystemControllerLog;
import com.iformall.common.Result;
import com.iformall.common.ResultData;
import com.iformall.controller.base.BaseController;
import com.iformall.domain.po.base.BaseEntity;
import com.iformall.domain.po.WxMerchantPowerBillConfig;
import com.iformall.service.WxMerchantPowerBillConfigService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;


/**
 * @author gongbiao
 */
@RestController
@RequestMapping("wxMerchantPowerBillConfig")
@Api(description = "商户电费生成配置")
public class WxMerchantPowerBillConfigController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private WxMerchantPowerBillConfigService wxMerchantPowerBillConfigService;


    @ApiOperation("查询数据列表")
    @GetMapping("/list")
    @SystemControllerLog(description = "查询数据列表")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    public ResultData findCouponDataList(@ModelAttribute WxMerchantPowerBillConfig wxMerchantPowerBillConfig, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxMerchantPowerBillConfigController::list");
        wxMerchantPowerBillConfig.setTenantId(getTenantId());
        wxMerchantPowerBillConfig.setSortColumns(BaseEntity.SortField.CreateDate_DESC);
        final PageInfo<WxMerchantPowerBillConfig> page = wxMerchantPowerBillConfigService.listAsPage(wxMerchantPowerBillConfig, pageNum, pageSize);
        return new ResultData(page);
    }


    @ApiOperation("新增")
    @PostMapping("/add")
    @SystemControllerLog(description = "新增")
    public ResultData add(@RequestBody WxMerchantPowerBillConfig wxMerchantPowerBillConfig) {
        logger.debug("[" + getIpAddr() + "] WxMerchantPowerBillConfigController::add");
        return wxMerchantPowerBillConfigService.saveOrUpdate(wxMerchantPowerBillConfig);
    }

    @ApiOperation("更新")
    @PostMapping("/update")
    @SystemControllerLog(description = "更新")
    public ResultData update(@RequestBody WxMerchantPowerBillConfig wxMerchantPowerBillConfig) {
        logger.debug("[" + getIpAddr() + "] WxMerchantPowerBillConfigController::update");
        return wxMerchantPowerBillConfigService.saveOrUpdate(wxMerchantPowerBillConfig);
    }

    @ApiOperation("删除")
    @GetMapping("/del")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "删除")
    public ResultData delete(Long id) {
        logger.debug("[" + getIpAddr() + "] WxMerchantPowerBillConfigController::delete");
        wxMerchantPowerBillConfigService.deleteById(id);
        return new ResultData(Result.SUCCESS, "删除成功", null);
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "id查询")
    public ResultData findById(Long id) {
        logger.debug("[" + getIpAddr() + "] WxMerchantPowerBillConfigController::findById");
        return new ResultData(Result.SUCCESS, "查询成功", wxMerchantPowerBillConfigService.getById(id));
    }


}
